var srcs = [];

window.addEventListener('detailinitial', initial, false);
BoncJs.sendLog("detail===loading....");
document.addEventListener('DOMContentLoaded', function updateWindowWidth() {
document.removeEventListener('DOMContentLoaded',updateWindowWidth, false);
    ev = document.createEvent('Event');
    ev.clientWidth = window.screen.width;
    ev.initEvent('detailinitial', false, true);
    window.dispatchEvent(ev);
}, false);

/**
 * 移除空白标签
 * @param {*} nodes 
 * @returns dom 对象
 */
function removeEmptyNodes (nodes) {
    return nodes.filter(node => {
        if (node.type == 'element' && node.tagName !== 'img') {
            node.children = removeEmptyNodes(node.children);
            return node.children.length;
        }
        
        return node;
    })
}

/**
 * 移除内容空格
 * @param {*} nodes 
 * @returns 
 */
function stripWhitespace (nodes) {
    return nodes.map(node => {
        if (node.type === 'element') {
            node.children = stripWhitespace(node.children);
        } else {
            node.content = node.content.trim();
        }
        return node;
    })
}

/**
 * 删除 style nodes
 * @param {*} nodes 
 * @returns 
 */
function removeStyle(nodes) {
    return nodes.map(node => {
        if (node.type === 'element') {
            node.children = removeStyle(node.children);
        }

        if (node.attributes.length) {
            node.attributes = node.attributes.filter(attr => {
                return attr.key !== 'style';
            });
        }

        return node;
    })
}

/**
 * 删除 style nodes
 * @param {*} nodes 
 * @returns 
 */
function removeStyle(nodes) {
    return nodes.map(node => {
        if (node.type === 'element' && node.attributes.length) {
            node.attributes = node.attributes.filter(attr => {
                return attr.key !== 'style';
            });

            node.children = removeStyle(node.children);
        }

        return node;
    })
}

// 初始化
function initial(e) {
    var container = document.getElementById('content');
    var text = BoncJs.getBodyContent() || '';

    var node = himalaya.parse(text);
    node = stripWhitespace(node);
    node = removeStyle(node);
    node = removeEmptyNodes(node);

    container.innerHTML = himalaya.stringify(node);

    handlerImages();
}

/**
 * 
 */
function handlerImages(){
    BoncJs.sendLog("handlerImages --- start");
    var imgTags = Array.prototype.slice.call(document.getElementsByTagName('img'));
     for ( var i = 0; i < imgTags.length; i++) {
            var imgTag = imgTags[i];
             srcs.push(imgTag.getAttribute('src'));
             imgTag.setAttribute('index', i);
             imgTag.onclick = function(i) {
                var index;
                index = parseInt(this.getAttribute('index'));
                BoncJs.previewImage(srcs,index);
            };
      }
      BoncJs.sendLog("handlerImages --- end ");
}
